g=love.graphics
screen = {w=g.getWidth(), h=g.getHeight()}
require 'logic'

local grid = {}
local overlay = false
local player = {x=1,y=1}
local tilesizes = {}
--tilesizes[1] = 16
--tilesizes[1] = 20
tilesizes[1] = 32
--tilesizes[3] = 40
--tilesizes[5] = 64
--tilesizes[6] = 80
--tilesizes[7] = 8
local cS = 1
local waitsize = 128
local gridCanvas = g.newCanvas()
local geom={}
geom[1]=g.newCanvas()
geom[2]=g.newCanvas()
geom[3]=g.newCanvas()
map = {}
map.data = {}
local color={}
color.wall = {80,80,80}
color.ground = {100,100,100}
color.top = {120,120,120}
as = {}
as.crits = g.newImage("crits.png")
quads={}
quads.robot = g.newQuad(0,33,32,32,164,165)
quads.shadow = g.newQuad(33,165-33,32,32,164,165)
quads.drone = g.newQuad(165-32,128-29,32,32,164,165)
local playerType = "walking"


function love.load()
	
	
	b={}
	--b[1]={x=screen.w/2-(64*1.5),y=0}
	--b[2]={x=screen.w/2-(32),y=0}
	--b[3]={x=screen.w/2+(32),y=0}
	b[4]={x=screen.w/2-(waitsize/2),y=screen.h/2-(waitsize/2)}
	
	zones={}
	
	controls = {}
	--controls[4] = {{x=b[1].x,y=b[1].y},{x=b[1].x+64,y=b[1].y},{x=b[1].x+64,y=b[1].y+64},{x=b[1].x,y=b[1].y+64}}
	--controls[3] = {{x=b[2].x,y=b[2].y},{x=b[2].x+64,y=b[2].y},{x=b[2].x+64,y=b[2].y+64},{x=b[2].x,y=b[2].y+64}}
	--controls[2] = {{x=b[3].x,y=b[3].y},{x=b[3].x+64,y=b[3].y},{x=b[3].x+64,y=b[3].y+64},{x=b[3].x,y=b[3].y+64}}
	controls[1] = {{x=b[4].x,y=b[4].y},{x=b[4].x+waitsize,y=b[4].y},{x=b[4].x+waitsize,y=b[4].y+waitsize},{x=b[4].x,y=b[4].y+waitsize}}
	
	makeGrid(tilesizes[cS])

	changeSize()
	changeSize()
	changeSize()
	changeSize()
	changeSize()
	changeSize()
	changeSize()
	changeSize()
	
	touch = {x=0,y=0}
	
end

function changeSize()
	cS = cS+1
	if cS > #tilesizes then
		cS = 1
	end
	makeGrid(tilesizes[cS])
	dotRect({w=map.w,h=map.h},{x=0,y=0,num=1},4)
	addRect(randRect(),randTile())
	drawMap()
end

function makeGrid(size)
	grid = {}
	map.w = 1280/size
	map.h = 800/size
	for i=0,map.w do
		for v=0,map.h do
			table.insert(grid,{x=i,y=v})
		end
	end
	
	gridCanvas:clear()
	g.setCanvas(gridCanvas)
	g.setColor(15,15,15)
	for i,v in ipairs(grid) do
		g.rectangle("line",v.x*tilesizes[cS],v.y*tilesizes[cS],tilesizes[cS],tilesizes[cS])
	end
	g.setCanvas()
	
	player.x = math.floor(1280/size/2)
	player.y = math.floor(800/size/2)
	move(0,0)
	
	
end

function transform()
	if playerType == "walking" then playerType = "flying" 
	elseif playerType == "flying" then playerType = "walking" end
		
end

function love.keypressed(key)
	if key == " " then
		
	end
end

function buildShapes()
	zoneShapes = {}
	controlShapes = {}
	for i,v in ipairs(zones) do
		local newShape = {}
		for j,k in ipairs(v) do
			table.insert(newShape,k.x)
			table.insert(newShape,k.y)
		end
		table.insert(zoneShapes,newShape)
	end
	
	for i,v in ipairs(controls) do
		local newShape = {}
		for j,k in ipairs(v) do
			table.insert(newShape,k.x)
			table.insert(newShape,k.y)
		end
		table.insert(controlShapes,newShape)
	end
end

function calcZones(xIn,yIn)
	zones[4] = {{x=0,y=0},{x=xIn,y=yIn},{x=screen.w,y=0}}
	zones[3] = {{x=0,y=0},{x=xIn,y=yIn},{x=0,y=screen.h}}
	zones[2] = {{x=screen.w,y=screen.h},{x=xIn,y=yIn},{x=0,y=screen.h}}
	zones[1] = {{x=screen.w,y=0},{x=xIn,y=yIn},{x=screen.w,y=screen.h}}
	b[4] = {x=xIn-(waitsize/2),y=yIn-(waitsize/2)}
	controls[1] = {{x=b[4].x,y=b[4].y},{x=b[4].x+waitsize,y=b[4].y},{x=b[4].x+waitsize,y=b[4].y+waitsize},{x=b[4].x,y=b[4].y+waitsize}}
	
	buildShapes()
end

function love.mousepressed(x,y,button)
	overlay = true
	touch.x=x
	touch.y=y
end

function move(dx,dy)
	local nx = player.x+dx
	local ny = player.y+dy
	local tile = findTile(nx,ny)
	
	if not tile then
		player.x=nx
		player.y=ny
		calcZones((player.x*tilesizes[cS])+(tilesizes[cS]/2),(player.y*tilesizes[cS])+(tilesizes[cS]/2))
	elseif tile and playerType == "flying" then
		player.x=nx
		player.y=ny
		calcZones((player.x*tilesizes[cS])+(tilesizes[cS]/2),(player.y*tilesizes[cS])+(tilesizes[cS]/2))
	end
		
end

function love.mousereleased(x,y,button)
	overlay = false
	
	touched = findZone(x,y)
	if touched.t=="zone" then doZone(touched.ref) end
	if touched.t=="control" then doControl(touched.ref) end
end

function doZone(input)
	if input == 1 then
		move(1,0)
	elseif input == 2 then
		move(0,1)
	elseif input == 3 then
		move(-1,0)
	elseif input == 4 then
		move (0,-1)
	end
end

function doControl(input)
	if input == 1 then
		transform()
	end
end



function findZone(xIn,yIn)
	for i,v in ipairs(controls) do
		if PointWithinShape(v,touch.x,touch.y) then
			return {ref=i,t="control"}
		end
	end
	
	for i,v in ipairs(zones) do
		if PointWithinShape(v,touch.x,touch.y) then
			return {ref=i,t="zone"}
		end
	end
	
end

function drawMap()
	geom[1]:clear()
	g.setCanvas(geom[1])
	g.setColor(color.ground)
	g.rectangle("fill",0,0,screen.w,screen.h)
	geom[2]:clear()
	geom[3]:clear()
	for i,v in ipairs(map.data) do
		if v.num == 1 then
			g.setCanvas(geom[2])
			g.setColor(color.wall)
			g.rectangle("fill",v.x*tilesizes[cS],v.y*tilesizes[cS],tilesizes[cS],tilesizes[cS])
			g.setCanvas(geom[3])
			g.setColor(color.top)
			g.rectangle("fill",v.x*tilesizes[cS],(v.y*tilesizes[cS])-(tilesizes[cS]*.75),tilesizes[cS],tilesizes[cS])
		end
	end
	g.reset()
end



function love.draw()
	local cTouch = false
	g.reset()
	g.draw(geom[1])
	g.setColor(255,255,255,50)
	g.draw(gridCanvas)
	
	g.reset()
	g.draw(geom[2])
	local px = player.x*tilesizes[cS]
	local py = (player.y*tilesizes[cS])-(tilesizes[cS]/2)
	local ptile = findTile(player.x,player.y)
	if ptile then
		py = py - (tilesizes[cS]*0.9)
	end
	g.draw(as.crits,quads.shadow,px,py+(tilesizes[cS]/4))
	if playerType == "walking" then g.draw(as.crits,quads.robot,px,py) end
	
	g.reset()
	g.draw(geom[3])
	
	g.reset()
	if playerType == "flying" and ptile then 
		g.draw(as.crits,quads.shadow,px,py+(tilesizes[cS]/4))
		g.draw(as.crits,quads.drone,px,py-(tilesizes[cS]*1.25)) 
	elseif playerType == "flying" then
		g.draw(as.crits,quads.drone,px,py-(tilesizes[cS]*0.75)) 
	end
	
	g.reset()
	
	if overlay then
	for i,v in ipairs(controls) do
		if PointWithinShape(v,touch.x,touch.y) then
			g.setColor(60,255,60,60)
			g.polygon("fill",controlShapes[i])
			g.reset()
			g.polygon("line",controlShapes[i])
			cTouch = true
		else
			g.reset()
			g.polygon("line",controlShapes[i])
		end
	end
	
	for i,v in ipairs(zones) do
		if PointWithinShape(v,touch.x,touch.y) and cTouch == false then
			g.setColor(60,255,60,60)
			g.polygon("fill",zoneShapes[i])
			g.reset()
			g.polygon("line",zoneShapes[i])
		else
			g.reset()
			g.polygon("line",zoneShapes[i])
		end
	end
	end
	
	g.reset()
	local text = "Gridsize: "..tostring(tilesizes[cS])
	local text2 = "press on the character to transform"
	g.print(text,10,10)
	g.print(text2,10,30)
end

function love.update(dt)
	if love.mouse.isDown("l") then
		overlay = true
		touch.x=love.mouse.getX()
		touch.y=love.mouse.getY()
	else
		overlay = false
	end
	

end

